from __future__ import annotations

from config import CONFIG
from eloquent import DatabaseManager, Schema

DB = DatabaseManager (CONFIG)
SCHEMA = Schema (DB)


def main (
) -> None:
    create_answered_flags ()
    drop_answered_column_in_answers ()


def create_answered_flags (
) -> None:
    with SCHEMA.create ('answered_flags') as table:
        table.big_increments ('id')
        table.unsigned_big_integer ('answer_id').comment ('回答')
        table.integer ('platform').comment ('プラットフォーム区分')
        table.boolean ('answered').default (False).comment ('回答済')
        table.unique (['answer_id', 'platform'])
        table.foreign ('answer_id').references ('id').on ('answers').on_update ('cascade').on_delete ('cascade')


def drop_answered_column_in_answers (
) -> None:
    with SCHEMA.table ('answers') as table:
        table.drop_column ('answered')


if __name__ == '__main__':
    main ()
